diff --git a/lib/hive/commands/setup.rb b/lib/hive/commands/setup.rb
new file mode 100644
index 00000000..da8201e3
--- /dev/null
+++ b/lib/hive/commands/setup.rb
@@ -0,0 +1,402 @@
+# frozen_string_literal: true
+
+require "json"
+require "open3"
+require "fileutils"
+require "net/http"
+require "timeout"
+require "uri"
+
+require "hive"
+require "hive/invoked_binary"
+require "hive/paths"
+require "hive/setup/diagnostics"
+require "hive/web/app_bundle"
+
+module Hive
+  module Commands
+    # `hive setup` — diagnose the host, bootstrap Hive-owned assets (qmd +
+    # Rails web bundle), install/start the daemon with the invoking binary,
+    # initialize or enroll the current repository, and optionally install
+    # the managed web service (`--service`).
+    #
+    # Phases always record outcomes so text, JSON `ok`, and process exit
+    # cannot disagree after a partial failure.
+    class Setup
+      SCHEMA = "hive-setup"
+      SCHEMA_VERSION = Hive::Schemas::SCHEMA_VERSIONS.fetch(SCHEMA)
+      QMD_PACKAGE = Hive::Setup::Diagnostics::QMD_PACKAGE
+      WEB_HEALTH_URL = "http://127.0.0.1:4567/health"
+      WEB_HEALTH_TIMEOUT = 15.0
+      WEB_HEALTH_ATTEMPT_TIMEOUT = 1.0
+      WEB_HEALTH_RETRY_INTERVAL = 0.1
+
+      Phase = Struct.new(:name, :ok, :detail, :error, keyword_init: true) do
+        def to_h
+          {
+            "name" => name,
+            "ok" => ok,
+            "detail" => detail,
+            "error" => error
+          }
+        end
+      end
+
+      def initialize(
+        project_path: Dir.pwd,
+        service: false,
+        no_bootstrap: false,
+        no_init: false,
+        json: false,
+        binary_path: nil,
+        diagnostics: nil,
+        app_bundle: nil,
+        qmd_installer: nil,
+        daemon_installer: nil,
+        web_installer: nil,
+        web_health_probe: nil,
+        web_health_timeout: WEB_HEALTH_TIMEOUT,
+        init_runner: nil,
+        enroll_runner: nil,
+        output: $stdout,
+        err: $stderr
+      )
+        @project_path = File.expand_path(project_path)
+        @service = service
+        @no_bootstrap = no_bootstrap
+        @no_init = no_init
+        @json = json
+        @binary_path = binary_path || Hive::InvokedBinary.path
+        @diagnostics = diagnostics
+        @app_bundle = app_bundle
+        @qmd_installer = qmd_installer || method(:default_install_qmd)
+        @daemon_installer = daemon_installer
+        @web_installer = web_installer
+        @web_health_probe = web_health_probe || method(:default_web_health_probe)
+        @web_health_timeout = Float(web_health_timeout)
+        @init_runner = init_runner || method(:default_init)
+        @enroll_runner = enroll_runner || method(:default_enroll)
+        @output = output
+        @err = err
+        @phases = []
+        @diag_report = nil
+        @web_bundle_refreshed = false
+      end
+
+      def call
+        @diag_report = run_diagnostics
+        unless @no_bootstrap
+          bootstrap_qmd if needs_qmd_bootstrap?
+          bootstrap_web_bundle if needs_web_bootstrap?
+          install_daemon
+          enroll_or_init unless @no_init
+          install_web_service if @service
+        end
+
+        overall_ok = overall_success?
+        emit_report(overall_ok)
+        raise Hive::Error, failure_summary unless overall_ok
+
+        overall_ok
+      end
+
+      attr_reader :phases, :diag_report
+
+      private
+
+      def run_diagnostics
+        report = (@diagnostics || Hive::Setup::Diagnostics.new).call
+        record_phase(
+          "diagnostics",
+          ok: report.ok,
+          detail: "#{report.results.count(&:ok?)}/#{report.results.length} checks ok",
+          error: report.ok ? nil : report.hard_failures.map { |r| "#{r.name}: #{r.fix || r.detail}" }.join("; ")
+        )
+        report
+      end
+
+      def needs_qmd_bootstrap?
+        row = @diag_report.results.find { |r| r.name == "qmd" }
+        row && row.bootstrappable
+      end
+
+      def needs_web_bootstrap?
+        row = @diag_report.results.find { |r| r.name == "web_bundle" }
+        row && row.bootstrappable
+      end
+
+      def bootstrap_qmd
+        begin
+          detail = @qmd_installer.call
+          record_phase("bootstrap_qmd", ok: true, detail: detail)
+        rescue StandardError => e
+          record_phase("bootstrap_qmd", ok: false, detail: nil, error: "#{e.class}: #{e.message}")
+        end
+      end
+
+      def bootstrap_web_bundle
+        begin
+          bundle = @app_bundle || Hive::Web::AppBundle.new
+          path = bundle.ensure_installed!
+          @web_bundle_refreshed = true
+          record_phase("bootstrap_web_bundle", ok: true, detail: path)
+        rescue StandardError => e
+          record_phase("bootstrap_web_bundle", ok: false, detail: nil, error: "#{e.class}: #{e.message}")
+        end
+      end
+
+      def install_daemon
+        begin
+          require "hive/commands/daemon/service_installer"
+          installer = @daemon_installer || Hive::Commands::Daemon::ServiceInstaller.new(
+            binary_path: @binary_path
+          )
+          result = installer.install!(autostart: true, force: true)
+          if result.success?
+            record_phase(
+              "daemon_install",
+              ok: true,
+              detail: "outcome=#{result.wire_outcome} unit=#{installer.target_path} binary=#{@binary_path}"
+            )
+          else
+            record_phase(
+              "daemon_install",
+              ok: false,
+              detail: result.wire_outcome,
+              error: installer.messages.last || "daemon install failed"
+            )
+          end
+        rescue StandardError => e
+          record_phase("daemon_install", ok: false, error: "#{e.class}: #{e.message}")
+        end
+      end
+
+      def enroll_or_init
+        initialized = project_initialized?
+        begin
+          if initialized
+            detail = @enroll_runner.call(@project_path)
+            record_phase("enroll", ok: true, detail: detail)
+          else
+            detail = @init_runner.call(@project_path)
+            record_phase("init", ok: true, detail: detail)
+          end
+        rescue SystemExit => e
+          name = initialized ? "enroll" : "init"
+          record_phase(name, ok: false, error: "SystemExit: exited with status #{e.status}")
+        rescue StandardError => e
+          name = initialized ? "enroll" : "init"
+          record_phase(name, ok: false, error: "#{e.class}: #{e.message}")
+        end
+      end
+
+      def install_web_service
+        begin
+          require "hive/commands/web/service_installer"
+          installer = @web_installer || Hive::Commands::Web::ServiceInstaller.new(
+            binary_path: @binary_path
+          )
+          active_before_install = @web_bundle_refreshed && !!installer.status_snapshot["service_active"]
+          # An already-active service is restarted explicitly below. Avoid an
+          # idempotent enable/load here (launchd rejects loading an already
+          # loaded plist, and systemd enable --now does not reload Rails code).
+          result = installer.install!(autostart: !active_before_install, force: true)
+          if result.success?
+            restarted = result.restarted
+            if active_before_install
+              restart_outcome = installer.restart!
+              unless restart_outcome == :ok
+                record_phase(
+                  "web_install",
+                  ok: false,
+                  detail: result.wire_outcome,
+                  error: installer.messages.last || "web service restart failed"
+                )
+                return
+              end
+              restarted = true
+            end
+            if active_before_install && !web_service_healthy?
+              record_phase(
+                "web_install",
+                ok: false,
+                detail: result.wire_outcome,
+                error: "health check failed at #{WEB_HEALTH_URL} within #{@web_health_timeout}s"
+              )
+              return
+            end
+            record_phase(
+              "web_install",
+              ok: true,
+              detail: "outcome=#{result.wire_outcome} unit=#{installer.target_path}" \
+                      " restarted=#{restarted} health_checked=#{active_before_install}"
+            )
+          else
+            record_phase(
+              "web_install",
+              ok: false,
+              detail: result.wire_outcome,
+              error: installer.messages.last || "web install failed"
+            )
+          end
+        rescue StandardError => e
+          record_phase("web_install", ok: false, error: "#{e.class}: #{e.message}")
+        end
+      end
+
+      def project_initialized?
+        File.directory?(File.join(@project_path, ".hive-state"))
+      end
+
+      def web_service_healthy?
+        Timeout.timeout(@web_health_timeout) do
+          @web_health_probe.call(WEB_HEALTH_URL, timeout: @web_health_timeout)
+        end
+      rescue Timeout::Error
+        false
+      end
+
+      def default_web_health_probe(url, timeout:)
+        uri = URI.parse(url)
+        deadline = Process.clock_gettime(Process::CLOCK_MONOTONIC) + timeout
+        loop do
+          remaining = deadline - Process.clock_gettime(Process::CLOCK_MONOTONIC)
+          return false unless remaining.positive?
+
+          begin
+            attempt_timeout = [ remaining, WEB_HEALTH_ATTEMPT_TIMEOUT ].min
+            http = Net::HTTP.new(uri.host, uri.port)
+            http.open_timeout = attempt_timeout
+            http.read_timeout = attempt_timeout
+            http.write_timeout = attempt_timeout if http.respond_to?(:write_timeout=)
+            response = http.get(uri.request_uri)
+            return true if response.is_a?(Net::HTTPSuccess)
+          rescue IOError, SystemCallError, SocketError, Timeout::Error, Net::HTTPBadResponse
+            # Retry below until the shared deadline.
+          end
+
+          remaining = deadline - Process.clock_gettime(Process::CLOCK_MONOTONIC)
+          return false unless remaining.positive?
+
+          sleep([ WEB_HEALTH_RETRY_INTERVAL, remaining ].min)
+        end
+      end
+
+      def record_phase(name, ok:, detail: nil, error: nil)
+        @phases << Phase.new(name: name, ok: ok, detail: detail, error: error)
+      end
+
+      def overall_success?
+        return false unless @diag_report&.ok
+        return true if @no_bootstrap
+
+        @phases.all?(&:ok)
+      end
+
+      def failure_summary
+        parts = []
+        if @diag_report && !@diag_report.ok
+          parts << "diagnostics failed: " + @diag_report.hard_failures.map { |r|
+            "#{r.name} (#{r.fix || r.detail})"
+          }.join("; ")
+        end
+        @phases.reject(&:ok).each do |phase|
+          parts << "#{phase.name}: #{phase.error || phase.detail}"
+        end
+        parts.empty? ? "setup failed" : parts.join(" | ")
+      end
+
+      def emit_report(overall_ok)
+        payload = {
+          "schema" => SCHEMA,
+          "schema_version" => SCHEMA_VERSION,
+          "ok" => overall_ok,
+          "service" => @service,
+          "no_bootstrap" => @no_bootstrap,
+          "no_init" => @no_init,
+          "binary_path" => @binary_path,
+          "project_path" => @project_path,
+          "web_url" => "http://127.0.0.1:4567",
+          "diagnostics" => @diag_report&.to_h,
+          "phases" => @phases.map(&:to_h)
+        }
+
+        if @json
+          @output.puts JSON.generate(payload)
+        else
+          emit_text(overall_ok, payload)
+        end
+      end
+
+      def emit_text(overall_ok, payload)
+        @output.puts "hive setup: #{overall_ok ? 'ok' : 'failed'}"
+        if @diag_report
+          @diag_report.results.each do |row|
+            mark = row.ok? ? "ok" : (row.bootstrappable ? "bootstrap" : "FAIL")
+            line = "  [#{mark}] #{row.name}: #{row.detail}"
+            line += "  → #{row.fix}" if row.fix
+            @output.puts line
+          end
+        end
+        @phases.each do |phase|
+          mark = phase.ok ? "ok" : "FAIL"
+          @output.puts "  phase #{phase.name}: #{mark}" \
+                       "#{phase.detail ? " — #{phase.detail}" : ""}" \
+                       "#{phase.error ? " — #{phase.error}" : ""}"
+        end
+        if overall_ok
+          if @service
+            @output.puts "hive setup: web UI at #{payload['web_url']}"
+          else
+            @output.puts "hive setup: run `hive web` in the foreground, or `hive setup --service` " \
+                         "to install the managed hive-web service"
+          end
+        else
+          @err.puts "hive setup: #{failure_summary}"
+        end
+      end
+
+      def default_install_qmd
+        prefix = File.join(Hive::Paths.data_home, "qmd")
+        FileUtils.mkdir_p(prefix)
+        cmd = [
+          "npm", "install", "--global",
+          "--prefix", prefix,
+          "--no-audit", "--no-fund",
+          QMD_PACKAGE
+        ]
+        out, err, status = Open3.capture3(*cmd)
+        raise Hive::Error, "qmd install failed: #{err.empty? ? out : err}" unless status.success?
+
+        "installed #{QMD_PACKAGE} under #{prefix}"
+      end
+
+      def default_init(project_path)
+        require "hive/commands/init"
+        # Non-interactive: pin the coding workflow; do not install daemon
+        # again (setup already did). Capture Init output.
+        Hive::Commands::Init.new(
+          project_path,
+          force: true,
+          json: true,
+          workflow: "coding",
+          workflow_input: StringIO.new("\n"),
+          workflow_output: StringIO.new,
+          emit: false
+        ).call
+        "initialized #{project_path}"
+      end
+
+      def default_enroll(project_path)
+        require "hive/commands/daemon"
+        name = File.basename(project_path)
+        # Ensure registry entry exists, then enable daemon for the project.
+        if Hive::Config.registered_projects.none? { |p| File.expand_path(p["path"].to_s) == project_path }
+          Hive::Config.register_project(name: name, path: project_path)
+        end
+        Hive::Commands::Daemon.new("enable", name, json: true, emit: false).call
+        "enrolled #{name}"
+      end
+    end
+  end
+end
diff --git a/lib/hive/commands/web.rb b/lib/hive/commands/web.rb
index eb3cd40f..230bc1f6 100644
--- a/lib/hive/commands/web.rb
+++ b/lib/hive/commands/web.rb
@@ -1,27 +1,173 @@
+# frozen_string_literal: true
+
+require "json"
 require "hive/config"
+require "hive/invoked_binary"
 require "hive/web/session_secret"
+require "hive/web/app_bundle"
+require "hive/web/loopback"
 
 module Hive
   module Commands
-    # Boots the hivebox web UI — a Rails app living in web/ at the repo root
-    # (shipped in the Docker image at /app/web). hive itself stays a plain
-    # CLI gem; the web tier is only supported where the Rails app and its
-    # bundle exist: the hivebox container or a source checkout.
+    # Boots the Hive web UI — a Rails app living in `web/` (source checkout /
+    # Docker `/app/web`) or installed under XDG data via AppBundle for gem
+    # installs. Also manages the optional per-user `hive-web` service
+    # (systemd-user / launchd), independent of `hive-daemon`.
+    #
+    # Subcommands:
+    #   (none)   — foreground Rails server (always available)
+    #   install  — write/register the managed service unit
+    #   start    — start the managed service
+    #   stop     — stop the managed service
+    #   status   — report managed service state
     class Web
-      def initialize(bind: nil, port: nil)
+      VALID_SUBCOMMANDS = %w[install start stop status].freeze
+      JSON_ALLOWED = %w[install status].freeze
+
+      def initialize(subcommand: nil, bind: nil, port: nil, force: false, json: false,
+                     binary_path: nil, unsafe: false)
+        @subcommand = subcommand
         @bind = bind
         @port = port
+        @force = force
+        @json = json
+        @binary_path = binary_path
+        @unsafe = unsafe
       end
 
       def call
+        if @subcommand.nil? || @subcommand.empty?
+          run_foreground
+        elsif VALID_SUBCOMMANDS.include?(@subcommand)
+          public_send(:"#{@subcommand}_service")
+        else
+          raise Hive::InvalidTaskPath,
+                "hive web: unknown subcommand #{@subcommand.inspect} " \
+                "(expected: #{VALID_SUBCOMMANDS.join(', ')}, or bare `hive web` for foreground)"
+        end
+      end
+
+      def install_service
+        require "hive/commands/web/service_installer"
+        installer = service_installer
+        result = installer.install!(autostart: true, force: @force)
+        installer.messages.each { |line| warn "hive: #{line}" } unless @json
+        emit_install_outcome(installer, result)
+      end
+
+      def start_service
+        require "hive/commands/web/service_installer"
+        installer = service_installer
+        kind = installer.start!
+        installer.messages.each { |line| warn "hive: #{line}" } unless @json
+        case kind
+        when :ok
+          puts "hive web: service started" unless @json
+        when :autostart_unavailable
+          raise Hive::Error, "systemd-user not available; cannot start hive-web service"
+        when :unsupported
+          raise Hive::Error, "web service start is not supported on this platform"
+        else
+          raise Hive::Error, installer.messages.last || "hive web start failed"
+        end
+      end
+
+      def stop_service
+        require "hive/commands/web/service_installer"
+        installer = service_installer
+        kind = installer.stop!
+        installer.messages.each { |line| warn "hive: #{line}" } unless @json
+        case kind
+        when :ok
+          puts "hive web: service stopped" unless @json
+        when :autostart_unavailable
+          raise Hive::Error, "systemd-user not available; cannot stop hive-web service"
+        when :unsupported
+          raise Hive::Error, "web service stop is not supported on this platform"
+        else
+          raise Hive::Error, installer.messages.last || "hive web stop failed"
+        end
+      end
+
+      def status_service
+        require "hive/commands/web/service_installer"
+        installer = service_installer
+        snap = installer.status_snapshot
+        active = snap["service_active"] == true
+        payload = {
+          "schema" => "hive-web-status",
+          "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-web-status"),
+          "ok" => active,
+          "platform" => snap["platform"],
+          "service_installed" => snap["service_installed"],
+          "service_enabled" => snap["service_enabled"],
+          "service_active" => snap["service_active"],
+          "unit_path" => snap["unit_path"],
+          "error" => active ? nil : "web service not active"
+        }
+        if @json
+          puts JSON.generate(payload)
+        else
+          state =
+            if snap["service_active"]
+              "active"
+            elsif snap["service_installed"]
+              "installed (not active)"
+            else
+              "not installed"
+            end
+          puts "hive web: #{state}"
+          puts "  unit: #{snap['unit_path']}" if snap["unit_path"]
+        end
+        raise Hive::Error, "web service not active" unless active
+      end
+
+      # Gate non-loopback binds (public for unit tests).
+      def apply_bind_policy!(bind, cfg)
+        return if Hive::Web::Loopback.address?(bind)
+
+        owner = cfg.dig("github", "owner").to_s.strip
+        if !owner.empty?
+          warn "hive web: WARNING binding #{bind} (non-loopback) with configured owner " \
+               "#{owner.inspect} — GitHub login is required; protect this endpoint."
+          return
+        end
+
+        if @unsafe
+          warn "hive web: WARNING binding #{bind} (non-loopback) with --unsafe and no " \
+               "configured web.github.owner — existing auth/claim flow still applies; " \
+               "this is not safe for untrusted networks."
+          return
+        end
+
+        raise Hive::Error,
+              "hive web: refusing non-loopback bind #{bind.inspect} without " \
+              "web.github.owner or --unsafe. Default local bind is 127.0.0.1. " \
+              "Set web.github.owner, pass --unsafe, or bind a loopback address."
+      end
+
+      private
+
+      def run_foreground
+        if @json
+          raise Hive::InvalidTaskPath,
+                "hive web has no JSON output (it runs a long-lived server). " \
+                "Use 'hive web status --json' or 'hive status --json'."
+        end
+
         cfg = Hive::Config.load_global_web
         bind = @bind || cfg.fetch("bind")
         port = (@port || cfg.fetch("port")).to_i
+
+        # Bind/auth policy runs BEFORE bundle resolve / db:prepare so a
+        # refused public bind never mutates state or downloads assets.
+        apply_bind_policy!(bind, cfg)
+
         app_dir = rails_app_dir
         unless app_dir
-          warn "hive web: the hivebox web app (web/) was not found. " \
-               "Run from the hivebox Docker image or a source checkout, " \
-               "or point HIVEBOX_WEB_APP_DIR at the Rails app."
+          warn "hive web: the Rails web app was not found. " \
+               "Run `hive setup` to install the matching web bundle, use a source " \
+               "checkout, the hivebox Docker image, or set HIVEBOX_WEB_APP_DIR."
           exit 1
         end
 
@@ -29,53 +175,42 @@ module Hive
 
         env = {
           "RAILS_ENV" => ENV.fetch("RAILS_ENV", "production"),
-          # Rails' secret_key_base derives from the same persisted secret the
-          # session cookies used pre-Rails, so recreating the container keeps
-          # sessions (the file lives on the /data mount).
           "SECRET_KEY_BASE" => ENV["SECRET_KEY_BASE"] ||
             Hive::Web::SessionSecret.load_or_create(cfg.fetch("session_secret_file")),
           "HIVEBOX_ORIGIN" => cfg.fetch("origin"),
-          # The solid_cable/cache/queue sqlite files must survive image
-          # upgrades — keep them in state_home (on /data in the container),
-          # not in the app dir.
           "HIVEBOX_STORAGE_DIR" => ENV["HIVEBOX_STORAGE_DIR"] ||
             File.join(Hive::Paths.state_home, "web-storage"),
           "BUNDLE_GEMFILE" => File.join(app_dir, "Gemfile")
-        }
+        }.merge(@app_bundle.runtime_env(app_dir))
+        # Signal loopback no-auth mode only when bind is loopback and
+        # config allows it. Rails still re-checks request.remote_ip.
+        if Hive::Web::Loopback.address?(bind) && cfg.fetch("local_loopback", true)
+          env[Hive::Web::Loopback::ENV_MODE] = "1"
+        else
+          env.delete(Hive::Web::Loopback::ENV_MODE)
+        end
         FileUtils.mkdir_p(env.fetch("HIVEBOX_STORAGE_DIR"))
 
         Dir.chdir(app_dir) do
-          # Idempotent: creates/migrates the solid-stack sqlite databases on
-          # first boot, no-ops afterwards. Array form — no shell involved.
-          # Typed error so a persistent failure surfaces as guidance, not a
-          # raw backtrace looping every 5s under the container supervisor.
           unless system(env, "bin/rails", "db:prepare")
             raise Hive::Error,
                   "hive web: db:prepare failed — check that " \
-                  "#{env.fetch("HIVEBOX_STORAGE_DIR")} is writable (the /data mount) " \
+                  "#{env.fetch("HIVEBOX_STORAGE_DIR")} is writable " \
                   "and that the web bundle is installed (cd #{app_dir} && bundle install)"
           end
           puts "hive web: listening on http://#{bind}:#{port}"
-          # Replace this process with the Rails server (array form, env hash;
-          # Kernel#exec never touches a shell when given an argv list).
           Kernel.exec env, "bin/rails", "server", "-b", bind, "-p", port.to_s
         end
       end
 
-      private
-
       def rails_app_dir
-        candidates = [
-          ENV["HIVEBOX_WEB_APP_DIR"],
-          File.expand_path("../../../web", __dir__)
-        ].compact
-        candidates.find { |dir| File.file?(File.join(dir, "config", "application.rb")) }
+        @app_bundle = Hive::Web::AppBundle.new
+        @app_bundle.resolve!
+      rescue Hive::Web::AppBundle::Error => e
+        warn "hive web: #{e.message}"
+        nil
       end
 
-      # Rails' production host authorization is inactive by default — the box
-      # assumes a trusted reverse proxy validates Host, exactly like the
-      # pre-Rails posture. Binding a public interface without that proxy
-      # exposes the app to DNS-rebinding / Host-injection, so make it loud.
       def warn_on_public_bind(bind, cfg)
         return unless bind.to_s == "0.0.0.0"
         return if cfg["origin"].to_s.start_with?("https://")
@@ -83,6 +218,61 @@ module Hive
         warn "hive web: WARNING binding 0.0.0.0 without an https origin — " \
              "ensure a trusted reverse proxy validates the Host header."
       end
+
+      def service_installer
+        require "hive/commands/web/service_installer"
+        Hive::Commands::Web::ServiceInstaller.new(
+          binary_path: @binary_path || Hive::InvokedBinary.path
+        )
+      end
+
+      def emit_install_outcome(installer, result)
+        if @json
+          if result.success?
+            puts JSON.generate(
+              "schema" => "hive-web-install",
+              "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-web-install"),
+              "ok" => true,
+              "outcome" => result.wire_outcome,
+              "platform" => installer.envelope_platform,
+              "unit_path" => installer.target_path,
+              "backup_path" => result.backup_path,
+              "restarted" => result.restarted,
+              "messages" => installer.messages
+            )
+          else
+            puts JSON.generate(
+              "schema" => "hive-web-install",
+              "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-web-install"),
+              "ok" => false,
+              "outcome" => result.wire_outcome,
+              "platform" => installer.envelope_platform,
+              "unit_path" => installer.target_path,
+              "messages" => installer.messages,
+              "error" => installer.messages.last || "web service install failed"
+            )
+            raise Hive::Error, installer.messages.last || "web service install failed"
+          end
+          return
+        end
+
+        case result.kind
+        when :written
+          puts "hive web: installed unit at #{installer.target_path}"
+        when :upgraded
+          puts "hive web: upgraded unit at #{installer.target_path}"
+        when :unchanged
+          puts "hive web: unit already up to date at #{installer.target_path}"
+        when :autostart_unavailable
+          puts "hive web: unit written at #{installer.target_path}; autostart not enabled on this host"
+        when :drifted
+          raise Hive::Error, installer.messages.last || "web unit drifted; re-run with --force"
+        when :failed
+          raise Hive::Error, installer.messages.last || "web service install failed"
+        when :unsupported
+          # message already warned
+        end
+      end
     end
   end
 end
